unit ituExplorerV2;

interface

uses
  LCLIntf, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Clipbrd, Dialogs, ExtCtrls, StdCtrls, ComCtrls, ActnList,
  LCLType, acuSQLDialectManager, ImgList, acuframework, utuMessage,
  IntegracaoDelphiSUML, acuObjectExplorer, Menus, Buttons, SynEdit,
  SynHighlighterSQL, SynCompletion, acuModel, acuRepositorySQL;

type

  TDLLDialog = class(TForm)
  protected
    procedure CreateParams(var Params: TCreateParams); override;
  public
    procedure BtnShowMessageClick(Sender: TObject);
    constructor Create(aOwner: TComponent); override;
  public
    ParentFormHandle: HWND;
  end;

  { TExplorerV2 }

  TExplorerV2 = class(TForm)
    actExecute: TAction;
    actCancel: TAction;
    edtClasse: TEdit;
    gbAgrupamento: TGroupBox;
    ilModel: TImageList;
    Label2: TLabel;
    lvXMLListResult: TListView;
    memXMLTextResult: TMemo;
    OQLObjects: TObjectExplorer;
    pnFiltroClasse: TPanel;
    pcXMLResults: TPageControl;
    rbHieraquia: TRadioButton;
    rbSequencial: TRadioButton;
    ReconnectDB: TAction;
    sbStatusBar: TStatusBar;
    spResultXML: TSplitter;
    spResultObject: TSplitter;
    SynCompletion1: TSynCompletion;
    SynEditOQL: TSynEdit;
    SynEditSQL: TSynEdit;
    SynSQLSyn1: TSynSQLSyn;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton10: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    ToolButton8: TToolButton;
    ToolButton9: TToolButton;
    tsList: TTabSheet;
    tsXML: TTabSheet;
    XMLQuery: TAction;
    OQLQuery: TAction;
    actResultsPanel: TAction;
    actModelPanel: TAction;
    ActionList1: TActionList;
    pnlEditor: TPanel;
    pnlModel: TPanel;
    splVertical: TSplitter;
    pnlResult: TPanel;
    tvModelExplorer: TTreeView;
//    con1: TADOConnection;
    il1: TImageList;
    pmCopiar: TPopupMenu;
    Copia: TMenuItem;
    pcEditor: TPageControl;
    tsOQL: TTabSheet;
    tsSQL: TTabSheet;
    pcResults: TPageControl;
    tsQueryResult: TTabSheet;
    tsError: TTabSheet;
    memErrorText: TMemo;
    pnlActionBar: TPanel;
    procedure actModelPanelExecute(Sender: TObject);
    procedure edtClasseChange(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure actResultsPanelExecute(Sender: TObject);
    procedure rbSequencialClick(Sender: TObject);
    procedure tvModelExplorerGetSelectedIndex(Sender: TObject; Node: TTreeNode);
    procedure tvModelExplorerItemExpanding(Sender: TObject; Node: TTreeNode; var AllowExpansion: Boolean);
    procedure XMLQueryExecute(Sender: TObject);
    procedure actExecuteExecute(Sender: TObject);
    procedure memOQLQuery2DragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure memOQLQuery2DragOver(Sender, Source: TObject; X, Y: Integer;  State: TDragState; var Accept: Boolean);
    procedure CopiaDadosObjeto(Sender: TObject);
    procedure OQLObjectstvExplorerKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure OQLObjectstvExplorerMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure ReconnectDBExecute(Sender: TObject);
    procedure pcEditorChange(Sender: TObject);
    procedure OQLQueryExecute(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
    fExecuting: Boolean;
    fMetaModel: acMetaModel;
    fMetaModelPersistenceMap: acMetaModelPersistenceMapSQL;
    fSession: acPersistenceSession;
    fConnectionString: string;
    fSQLDialect: acAbstractSQLDialect;
    fSchema: String;
    fUtil: TUtil;
    fLastExecErrorFlag: Boolean;
    procedure MontarModelExploreSequencial(Sender: TObject; Node: TTreeNode);
    procedure MontarModelExploreHieraquia(Sender: TObject; Node: TTreeNode);
    procedure SetMetaModel(const Value: acMetaModel);
    procedure ResizeColumns(piListView: TListView);
    function GetStringEntreParenteses(piString : string) : string;
    function GetNumeroDeStringOID (piString : string) : string;
    procedure CopiaTextoObjeto (piObjeto : TTreeNode);
    function BuscaParcialClasse(piCLasse: string; piFiltrar: boolean): boolean;
   protected
    procedure CreateParams(var Params : TCreateParams); override;
    function Connect : acPersistenceSession;

  public
    { Public declarations }
    property MetaModel: acMetaModel read fMetaModel write SetMetaModel;
    property Util: TUtil read fUtil;
    property SQLDialect: acAbstractSQLDialect read fSQLDialect;
    property Schema: String read fSchema;
  end;

var
  ExplorerV2: TExplorerV2;

implementation

uses ituDataBaseLogin, DateUtils, acuObject, acuOQL, acuOQLtoSQLTranslator,
      ituOQLParams;

{$R *.dfm}

function TiraAcentos(const s : string): string;
const
  Acentos = '';
   Letras = 'AIOUEAIOUEAIOUEAOAIOUEaioueaioueaioueaoaioue';
var
  i: Integer;
begin
  Result := S;
  for i := 1 to Length(Acentos) do
    while Pos(acentos[i],Result)>0 do
      Result[Pos(acentos[i],Result)]:=Letras[i];
end;
procedure TExplorerV2.actExecuteExecute(Sender: TObject);
var lSession: acPersistenceSession;
    lList: acPersistentObjectList;
    lStart: TDateTime;
    lOQLQuery: acAbstractOQLQuery;
    lOQLParams: TOQLParams;
    lResultField: utField;
    lEnum: acEnumerator;
    lField: utField;
    lColumn: TListColumn;
    lListItem: TListItem;
    lEnumAtt: acEnumerator;
    lFirstItemFlag: Boolean;
    lCount: integer;
begin
  lCount := 0;
  if (SynEditOQL.Text <> '') and (not fExecuting) then
  begin
    fExecuting := True;
    try
      lSession := Connect;
      if Assigned(lSession) then
      begin
        SynEditSQL.Text := '';
        OQLObjects.SetList(nil, '');
        lvXMLListResult.Clear;
        lvXMLListResult.Columns.Clear;
        pcResults.ActivePageIndex := 0;

        if assigned(fSession) then FreeAndNil(fSession);
        fSession := lSession;

        if OQLQuery.Checked then
        begin
          lList := acPersistentObjectList.Create;
          try
            sbStatusBar.Panels[0].Text := 'Executing query...';
            sbStatusBar.Panels[1].Text := '';
            sbStatusBar.Panels[2].Text := '';
            Application.ProcessMessages;
            if SynEditOQL.SelText = ''
              then lOQLQuery := acOQLQuery.Create(fSession, SynEditOQL.Text)
              else lOQLQuery := acOQLQuery.Create(fSession, SynEditOQL.SelText);
            try
              if lOQLQuery.Parameters.Count > 0 then
              begin
                lOQLParams := TOQLParams.Create(nil, lOQLQuery);
                try
                  lOQLParams.ShowModal;
                finally
                  lOQLParams.free;
                end;
              end;

              lStart := Now;

              (lOQLQuery as acOQLQuery).LoadList(lList);
              SynEditSQL.Text := lOQLQuery.GetSQLText;
            finally
              lOQLQuery.Free;
            end;

            sbStatusBar.Panels[2].Text := SysUtils.TimeToStr(TimeOf(Now - lStart));
            sbStatusBar.Panels[0].Text := 'Query completed.';
            if lList.Count <= 1 then
              sbStatusBar.Panels[1].Text := inttostr(lList.Count) + ' object'
            else
              sbStatusBar.Panels[1].Text := inttostr(lList.Count) + ' objects';
            OQLObjects.SetList(lList, 'OQL Results');

            fLastExecErrorFlag := False;
            if not actResultsPanel.Checked then actResultsPanel.Execute;
          finally
            lList.Free;
          end;
        end
        else
        begin
          pcXMLResults.ActivePageIndex := 0;
          sbStatusBar.Panels[0].Text := 'Executing query...';
          sbStatusBar.Panels[1].Text := '';
          sbStatusBar.Panels[2].Text := '';
          Application.ProcessMessages;

          if SynEditOQL.SelText = ''
            then lOQLQuery := acDataSetOQLQuery.Create(fSession, SynEditOQL.Text)
            else lOQLQuery := acDataSetOQLQuery.Create(fSession, SynEditOQL.SelText);
          try
            if lOQLQuery.Parameters.Count > 0 then
            begin
              lOQLParams := TOQLParams.Create(nil, lOQLQuery);
              try
                lOQLParams.ShowModal;
              finally
                lOQLParams.free;
              end;
            end;

            lStart := Now;

            lResultField := utField.Create;
            try
              lResultField.Name := 'ROOT';
              (lOQLQuery as acDataSetOQLQuery).LoadDataSet(lResultField);
              SynEditSQL.Text := lOQLQuery.GetSQLText;
              memXMLTextResult.Text := lResultField.GetXMLString([XMLOptions.xoLegible]);

              lvXMLListResult.Items.BeginUpdate;
              try
                //Adiciona as colunas no listview
                if (lResultField.HasField('DATAPACKET')) and (lResultField.FieldByName('DATAPACKET').HasField('METADATA')) then
                begin
                  lEnum := lResultField.FieldByName('DATAPACKET').FieldByName('METADATA').FieldByName('FIELDS').GetFieldsEnumerator;
                  try
                    while not lEnum.EOL do
                    begin
                      lField := utField(lEnum.Current);
                      lColumn := lvXMLListResult.Columns.Add;
                      lColumn.Caption := lField.AttributeByName('Name').AsString;
                      lColumn.AutoSize := True;
                      lEnum.MoveNext;
                    end;
                  finally
                    lEnum.Free;
                  end;
                end;

                if (lResultField.HasField('DATAPACKET')) and (lResultField.FieldByName('DATAPACKET').HasField('ROWDATA')) then
                begin
                  lCount := lResultField.FieldByName('DATAPACKET').FieldByName('ROWDATA').AttributeByName('Count').AsInteger;
                  lEnum := lResultField.FieldByName('DATAPACKET').FieldByName('ROWDATA').GetFieldsEnumerator;
                  try
                    while not lEnum.EOL do
                    begin
                      lField := utField(lEnum.Current);
                      lListItem := lvXMLListResult.Items.Add;
                      lEnumAtt := lField.GetAttibutesEnumerator;
                      try
                        lFirstItemFlag := true;
                        while not lEnumAtt.EOL do
                        begin
                          if lFirstItemFlag then
                          begin
                            lListItem.Caption := utAttribute(lEnumAtt.Current).AsString;
                            lFirstItemFlag := false;
                          end
                          else
                            lListItem.SubItems.Add(utAttribute(lEnumAtt.Current).AsString);
                          lEnumAtt.MoveNext;
                        end;
                      finally
                        lEnumAtt.Free;
                      end;
                      lEnum.MoveNext;
                    end;
                  finally
                    lEnum.Free;
                  end;
                end;
              finally
                lvXMLListResult.Items.EndUpdate;
              end;

            finally
              lResultField.free;
            end;
//            ResizeColumns(lvXMLListResult);
          finally
            lOQLQuery.Free;
          end;
          sbStatusBar.Panels[2].Text := SysUtils.TimeToStr(TimeOf(Now - lStart));
          if lCount <= 1 then
            sbStatusBar.Panels[1].Text := inttostr(lCount) + ' row'
          else
            sbStatusBar.Panels[1].Text := inttostr(lCount) + ' rows';
          sbStatusBar.Panels[0].Text := 'Query completed.';

          fLastExecErrorFlag := False;
          if not actResultsPanel.Checked then actResultsPanel.Execute;
        end;
      end;
    except
      on e: Exception do
        begin
          fLastExecErrorFlag := True;
          memErrorText.Text := e.Message;
          pcResults.ActivePageIndex := 1;
          sbStatusBar.Panels[0].Text := 'Query completed with errors.';
          if not actResultsPanel.Checked then actResultsPanel.Execute;
        end;
    end;
  end;
  fExecuting := False;
end;

procedure TExplorerV2.actModelPanelExecute(Sender: TObject);
var
  lAction : TAction;
begin
  lAction := (Sender as TAction);
  lAction.Checked := not lAction.Checked;
  if lAction.Checked then
  begin
    pnlModel.Visible := True;
    if pnlModel.Width <= 10 then
      pnlModel.Width := 20;
  end
  else
  begin
    pnlModel.Visible := False;
  end;
end;

procedure TExplorerV2.edtClasseChange(Sender: TObject);
begin
  tvModelExplorer.Items.Clear;
  MetaModel := fUtil.MetaModel;
end;

procedure TExplorerV2.actResultsPanelExecute(Sender: TObject);
var
  lAction : TAction;
begin
  lAction := (Sender as TAction);
  lAction.Checked := not lAction.Checked;
  if lAction.Checked then
  begin
    if fLastExecErrorFlag then
    begin
      pcResults.ActivePageIndex := 1;
      pnlResult.Visible := True;
      spResultXML.Visible := True;
      spResultXML.Align := alBottom;
      if pnlResult.Height <= 10 then
        pnlResult.Height := 20;
    end
    else
    begin
      if OQLQuery.Checked then
      begin
        OQLObjects.Visible := True;
        spResultObject.Visible := True;
        spResultObject.Align := alRight;
        spResultXML.Visible := False;
      end
      else
      begin
        pcResults.ActivePageIndex := 0;
        spResultObject.Visible := False;
        pnlResult.Visible := True;
        spResultXML.Visible := True;
        spResultXML.Align := alBottom;
      end;
    end;
  end
  else
  begin
    spResultXML.Align := alNone;
    spResultObject.Align := alNone;
    spResultXML.Visible := False;
    spResultObject.Visible := False;
    pnlResult.Visible := False;
    OQLObjects.Visible := False;
  end;
end;

procedure TExplorerV2.rbSequencialClick(Sender: TObject);
begin

end;



procedure TExplorerV2.tvModelExplorerGetSelectedIndex(Sender: TObject; Node: TTreeNode);
begin
  Node.SelectedIndex := Node.ImageIndex;
end;

procedure TExplorerV2.OQLQueryExecute(Sender: TObject);
begin
  OQLQuery.Checked := True;
  XMLQuery.Checked := False;
end;

function TExplorerV2.Connect: acPersistenceSession;
var
    lDataBaseLogin: TDataBaseLogin;
    lModalResult: Integer;
begin
  lModalResult := mrOk;
  Result := Nil;
  lDataBaseLogin := TDataBaseLogin.Create(Self);
  try
    lDataBaseLogin.ProjectFileName := ExtractFileName(fUtil.StarUMLApp.ProjectManager.FileName);
    while (lModalResult = mrOk) and (not Assigned(Result)) do
    begin
      if fConnectionString = '' then
      begin
        lModalResult := lDataBaseLogin.ShowModal;
        if lModalResult = mrok then
        begin
          if lDataBaseLogin.rbDSN.Checked then
          begin
             fConnectionString := format('DSN=%s;UID=%s;PWD=%s',[lDataBaseLogin.cbODBCD_DSN.Text, lDataBaseLogin.edtUsuario.Text, lDataBaseLogin.edtPassword.Text]);
             fSQLDialect := lDataBaseLogin.cbDialect.Items.Objects[lDataBaseLogin.cbDialect.ItemIndex] as acAbstractSQLDialect;
             sbStatusBar.Panels[3].Text := Format('%s.%s(%s)', [lDataBaseLogin.cbDialect.Text, lDataBaseLogin.cbODBCD_DSN.Text, lDataBaseLogin.edtUsuario.Text]);
          end
          else
          begin
            if lDataBaseLogin.edtDatabaseName.Text <> ''
              then fConnectionString := format('DRIVER=%s;Server=%s;Database=%s;UID=%s;PWD=%s',[lDataBaseLogin.cbODBCD_DRIVERS.Text, lDataBaseLogin.edtServerName.Text, lDataBaseLogin.edtDatabaseName.Text, lDataBaseLogin.edtUsuario.Text, lDataBaseLogin.edtPassword.Text])
              else fConnectionString := format('DRIVER=%s;Server=%s;UID=%s;PWD=%s',[lDataBaseLogin.cbODBCD_DRIVERS.Text, lDataBaseLogin.edtServerName.Text, lDataBaseLogin.edtUsuario.Text, lDataBaseLogin.edtPassword.Text]);
            fSQLDialect := lDataBaseLogin.cbDialect.Items.Objects[lDataBaseLogin.cbDialect.ItemIndex] as acAbstractSQLDialect;
            if lDataBaseLogin.edtDatabaseName.Text <> ''
              then sbStatusBar.Panels[3].Text := Format('%s.%s.%s(%s)', [lDataBaseLogin.cbDialect.Text, lDataBaseLogin.edtServerName.Text, lDataBaseLogin.edtDatabaseName.Text, lDataBaseLogin.edtUsuario.Text])
              else sbStatusBar.Panels[3].Text := Format('%s.%s.Default(%s)', [lDataBaseLogin.cbDialect.Text, lDataBaseLogin.edtServerName.Text, lDataBaseLogin.edtUsuario.Text]);
          end;
        end
        else exit;
      end;

      if fConnectionString <> '' then
      begin
        try
          Result := PersistenceManager.OpenSession(fMetaModelPersistenceMap, fConnectionString);
          (Result.Repository as acRepositorySQL).SQLDialect := fSQLDialect;

          if actResultsPanel.Checked then actResultsPanel.Execute;
          sbStatusBar.Panels[0].Text := '';
          sbStatusBar.Panels[1].Text := '';
          sbStatusBar.Panels[2].Text := '';
          OQLObjects.SetList(nil, '');
          lvXMLListResult.Clear;
          lvXMLListResult.Columns.Clear;
          memXMLTextResult.Clear;
          pcResults.ActivePageIndex := 0;

        Except
          on e:Exception do
          begin
            fConnectionString := '';
            ShowMessage(e.Message);
          end;
        end;
      end;
    end;
  finally
    lDataBaseLogin.Free;
  end;
end;

procedure TExplorerV2.CopiaDadosObjeto(Sender: TObject);
begin
  if Assigned(OQLObjects.tvExplorer.Selected) then
    CopiaTextoObjeto(OQLObjects.tvExplorer.Selected);
end;

procedure TExplorerV2.CopiaTextoObjeto(piObjeto: TTreeNode);
var
  lString : string;
begin
  lString := piObjeto.Text;
  lString := GetNumeroDeStringOID(GetStringEntreParenteses(lString));
  if lString <> '' then
    Clipbrd.Clipboard.AsText := lString;
end;

function TExplorerV2.BuscaParcialClasse(piCLasse: string;  piFiltrar: boolean): boolean;
var lClasseTree,
    lClasseP : string;
begin
   if piFiltrar then
   begin
     lClasseP     :=  TiraAcentos(trim(UpperCase(edtClasse.Text)));
     lClasseTree  :=  TiraAcentos(trim(UpperCase(piCLasse)));
     result :=  Pos(lClasseP,lClasseTree) > 0;
   end
   else
   begin
     result := true;
   end;

end;

procedure TExplorerV2.CreateParams(var Params: TCreateParams);
begin
  inherited CreateParams(Params);
  {$IFDEF LCLWin32}
//  Params.WndParent := 0;
  {$ENDIF}
end;

procedure TExplorerV2.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action := caFree;
end;

procedure TExplorerV2.FormCreate(Sender: TObject);
var   lMetaModelGenOpt: TMetaModelGenerationOptions;
begin

  lMetaModelGenOpt.CheckDBAttributeNameLength := true;
  lMetaModelGenOpt.CheckDBTableNameLength := true;

  fUtil := TUtil.Create;
  fUtil.AlimentarMetamodel(lMetaModelGenOpt, nil);
  FMetaModelPersistenceMap := fUtil.MetaModelPersistenceMap;
  MetaModel := fUtil.MetaModel;
end;

procedure TExplorerV2.FormDestroy(Sender: TObject);
begin
  fUtil.Free;
end;

procedure TExplorerV2.MontarModelExploreSequencial(Sender: TObject; Node: TTreeNode);
var lClassTicket: acClassTicket;
    lAttributeTicket: acAttributeTicket;
    lRelationTicket: acRelationTicket;
    lCardinality: string;
    lEnumerator: acEnumerator;
    li: integer;
    targetNode :  TTreeNode;
    lFiltro : boolean;
begin
  lFiltro  := trim(edtClasse.Text) <> '';
  if Node.HasChildren and (Node.Count = 0)then
  begin
    Node.Owner.BeginUpdate;
    try
      if (TObject(Node.Data) is acMetaModel) then
      begin
        lEnumerator := acMetaModel(Node.Data).ClassTickets.GetEnumerator;
        while not lEnumerator.EOL do
        begin
          lClassTicket := acClassTicket(lEnumerator.Current);
          if BuscaParcialClasse(lClassTicket.PersistentObjectClassName,lFiltro) then
          begin
            targetNode := Node.Owner.AddChildObject(Node, lClassTicket.PersistentObjectClassName, lClassTicket);
            targetNode.ImageIndex := 6;
            targetNode.HasChildren := True;
          end;
          lEnumerator.MoveNext;
        end;
      end
      else if (TObject(Node.Data) is acClassTicket) then
      begin
        lClassTicket := acClassTicket(Node.Data);
        repeat
          for li := 0 to pred(lClassTicket.Attributes.Count) do
          begin
            lAttributeTicket := acAttributeTicket(lClassTicket.Attributes.Objects[li]);
            if lAttributeTicket.Stereotype = acAttributeStereotype.pvPersistent then
            begin
              targetNode := Node.Owner.AddChildObject(Node, lAttributeTicket.AttributeName + ': ' + lAttributeTicket.AttributeType, lAttributeTicket);
              if lAttributeTicket.Mandatory then
                targetNode.ImageIndex := 5
              else
                targetNode.ImageIndex := 0;
            end;
          end;
          for li := 0 to pred(lClassTicket.RelationTicketsIn.Count) do
          begin
            lRelationTicket := acRelationTicket(lClassTicket.RelationTicketsIn.Objects[li]);
            if lRelationTicket.DestinationMaxMultiplicity = N
              then lCardinality := '*'
              else lCardinality := inttostr(lRelationTicket.DestinationMaxMultiplicity);
            if lRelationTicket.DestinationPropertyName <> '' then
            begin
              targetNode := Node.Owner.AddChildObject(Node, lRelationTicket.DestinationPropertyName + ': (' + lCardinality + ') ' + lRelationTicket.OriginClassTicket.PersistentObjectClassName, lRelationTicket.OriginClassTicket);
              targetNode.HasChildren := True;

              if lRelationTicket.DestinationMaxMultiplicity = N then
              begin
                if lRelationTicket.DestinationMinMultiplicity = 1 then
                  targetNode.ImageIndex := 4
                else
                  targetNode.ImageIndex := 2;
              end
              else
              begin
                if lRelationTicket.DestinationMinMultiplicity = 1 then
                  targetNode.ImageIndex := 3
                else
                  targetNode.ImageIndex := 1;
              end;
            end;
          end;
          for li := 0 to pred(lClassTicket.RelationTicketsOut.Count) do
          begin
            lRelationTicket := acRelationTicket(lClassTicket.RelationTicketsOut.Objects[li]);
            if lRelationTicket.OriginPropertyName <> '' then
            begin
              if lRelationTicket.OriginMaxMultiplicity = N
                then lCardinality := '*'
                else lCardinality := inttostr(lRelationTicket.OriginMaxMultiplicity);
              targetNode := Node.Owner.AddChildObject(Node, lRelationTicket.OriginPropertyName + ': (' + lCardinality + ') ' + lRelationTicket.DestinationClassTicket.PersistentObjectClassName, lRelationTicket.DestinationClassTicket);
              targetNode.HasChildren := True;
              if lRelationTicket.OriginMaxMultiplicity = N then
              begin
                if lRelationTicket.DestinationMinMultiplicity = 1 then
                  targetNode.ImageIndex := 4
                else
                  targetNode.ImageIndex := 2;
              end
              else
              begin
                if lRelationTicket.DestinationMinMultiplicity = 1 then
                  targetNode.ImageIndex := 3
                else
                  targetNode.ImageIndex := 1;
              end;
            end;
          end;
          lClassTicket := lClassTicket.ParentClassTicket;
        until lClassTicket = nil;
      end;
    finally
      Node.Owner.EndUpdate;
    end;
  end;

end;

procedure TExplorerV2.MontarModelExploreHieraquia(Sender: TObject; Node: TTreeNode);
var lClassTicket: acClassTicket;
    lAttributeTicket: acAttributeTicket;
    lRelationTicket: acRelationTicket;
    lCardinality: string;
    lEnumerator: acEnumerator;
    li: integer;
    lNodeParent,
    targetNode :  TTreeNode;
    lFiltro : boolean;
begin
  lFiltro  := trim(edtClasse.Text) <> '';
  if Node.HasChildren {and (Node.Count = 0)}then
  begin
    Node.Owner.BeginUpdate;
    try
      if (TObject(Node.Data) is acMetaModel) then
      begin
        //Carregas o pai
        lEnumerator := acMetaModel(Node.Data).ClassTickets.GetEnumerator;
        try
          while not lEnumerator.EOL do
          begin
            lClassTicket := acClassTicket(lEnumerator.Current);
            if not Assigned(lClassTicket.ParentClassTicket) then
            begin
              if  BuscaParcialClasse(lClassTicket.PersistentObjectClassName,lFiltro) then
              begin
                targetNode := Node.Owner.AddChildObject(Node, lClassTicket.PersistentObjectClassName, lClassTicket);
                targetNode.ImageIndex := 6;
                targetNode.HasChildren := True;
              end;
            end;
            lEnumerator.MoveNext;
          end;
        finally
          lEnumerator.Free;
        end;
        //Carrega os filhos

        lEnumerator := acMetaModel(Node.Data).ClassTickets.GetEnumerator;
        try
          while not lEnumerator.EOL do
          begin
            lClassTicket := acClassTicket(lEnumerator.Current);
            if Assigned(lClassTicket.ParentClassTicket) then
            begin
              if  BuscaParcialClasse(lClassTicket.PersistentObjectClassName,lFiltro) then
              begin
                lNodeParent :=  Node.Owner.FindNodeWithData(lClassTicket.ParentClassTicket);
                if Assigned(lNodeParent) then
                begin
                  targetNode := Node.Owner.AddChildObject(lNodeParent, lClassTicket.PersistentObjectClassName, lClassTicket);
                end
                else
                begin
                  targetNode := Node.Owner.AddChildObject(Node, lClassTicket.PersistentObjectClassName, lClassTicket);
                end;
                targetNode.ImageIndex := 6;
                targetNode.HasChildren := True;
              end;
            end;
            lEnumerator.MoveNext;
          end;
        finally
          lEnumerator.Free;
        end;
      end
      else if (TObject(Node.Data) is acClassTicket) then
      begin
        lClassTicket := acClassTicket(Node.Data);
        //repeat
          for li := 0 to pred(lClassTicket.Attributes.Count) do
          begin
            lAttributeTicket := acAttributeTicket(lClassTicket.Attributes.Objects[li]);
            if lAttributeTicket.Stereotype = acAttributeStereotype.pvPersistent then
            begin
              targetNode := Node.Owner.AddChildObject(Node, lAttributeTicket.AttributeName + ': ' + lAttributeTicket.AttributeType, lAttributeTicket);
              if lAttributeTicket.Mandatory then
                targetNode.ImageIndex := 5
              else
                targetNode.ImageIndex := 0;
            end;
          end;
          for li := 0 to pred(lClassTicket.RelationTicketsIn.Count) do
          begin
            lRelationTicket := acRelationTicket(lClassTicket.RelationTicketsIn.Objects[li]);
            if lRelationTicket.DestinationMaxMultiplicity = N
              then lCardinality := '*'
              else lCardinality := inttostr(lRelationTicket.DestinationMaxMultiplicity);
            if lRelationTicket.DestinationPropertyName <> '' then
            begin
              targetNode := Node.Owner.AddChildObject(Node, lRelationTicket.DestinationPropertyName + ': (' + lCardinality + ') ' + lRelationTicket.OriginClassTicket.PersistentObjectClassName, lRelationTicket.OriginClassTicket);
              targetNode.HasChildren := True;

              if lRelationTicket.DestinationMaxMultiplicity = N then
              begin
                if lRelationTicket.DestinationMinMultiplicity = 1 then
                  targetNode.ImageIndex := 4
                else
                  targetNode.ImageIndex := 2;
              end
              else
              begin
                if lRelationTicket.DestinationMinMultiplicity = 1 then
                  targetNode.ImageIndex := 3
                else
                  targetNode.ImageIndex := 1;
              end;
            end;
          end;
          for li := 0 to pred(lClassTicket.RelationTicketsOut.Count) do
          begin
            lRelationTicket := acRelationTicket(lClassTicket.RelationTicketsOut.Objects[li]);
            if lRelationTicket.OriginPropertyName <> '' then
            begin
              if lRelationTicket.OriginMaxMultiplicity = N
                then lCardinality := '*'
                else lCardinality := inttostr(lRelationTicket.OriginMaxMultiplicity);
              targetNode := Node.Owner.AddChildObject(Node, lRelationTicket.OriginPropertyName + ': (' + lCardinality + ') ' + lRelationTicket.DestinationClassTicket.PersistentObjectClassName, lRelationTicket.DestinationClassTicket);
              targetNode.HasChildren := True;
              if lRelationTicket.OriginMaxMultiplicity = N then
              begin
                if lRelationTicket.DestinationMinMultiplicity = 1 then
                  targetNode.ImageIndex := 4
                else
                  targetNode.ImageIndex := 2;
              end
              else
              begin
                if lRelationTicket.DestinationMinMultiplicity = 1 then
                  targetNode.ImageIndex := 3
                else
                  targetNode.ImageIndex := 1;
              end;
            end;
          end;
         //lClassTicket := lClassTicket.ParentClassTicket;
         //until lClassTicket = nil;
      end;
    finally
      Node.Owner.EndUpdate;
    end;
  end;

end;

procedure TExplorerV2.FormShow(Sender: TObject);
begin
  OQLQuery.Execute;

  spResultObject.Visible := False;
  spResultObject.Align := alNone;
  spResultXML.Visible := False;
  spResultXML.Align := alNone;

  pnlResult.Visible := False;
  pcEditor.ActivePageIndex := 0;
  pcResults.ActivePageIndex := 1;
end;

function TExplorerV2.GetNumeroDeStringOID(piString: string): string;
var
  lString : string;
  lEnum : Integer;
begin
  lString := '';
  // Verifica se a string tem mais que 4 caracteres
  if  Length(piString) > 4  then
  begin
    // Extrai os 4 primeiros caracteres da string
    for lEnum := 1 to 4  do
    begin
      lString := Concat(lString,piString[lEnum])
    end;
    // Se a string comear com OID: esses 4 primeiro caracteres sero excludos
    if lString = 'OID:' then
    begin
      lString := '';
      for lEnum := 5 to Length(piString)  do
      begin
        lString := Concat(lString,piString[lEnum])
      end;
    end
    // Caso contrrio copia-se a string toda
    else
    begin
      lString := '';
      for lEnum := 1 to Length(piString)  do
      begin
        lString := Concat(lString,piString[lEnum])
      end;
    end;
  end
  else
  begin
    lString := piString;
  end;
  Result := lString;  
end;

function TExplorerV2.GetStringEntreParenteses(piString: string): string;
var
  lString : string;
  lEnum : Integer;
  flagDadosDesejados : Boolean;
begin
  flagDadosDesejados := False;
  lString := '';
  for lEnum := 1 to Length(piString)  do
  begin
    // Fim dos dados entre parenteses
    if piString[lEnum] = ')' then
      flagDadosDesejados := False;
    if flagDadosDesejados then
    begin
      lString := Concat(lString,piString[lEnum])
    end;
    // Inicio dos dados entre parenteses
    if piString[lEnum] = '(' then
      flagDadosDesejados := True;
  end;
  Result := lString;
end;

procedure TExplorerV2.memOQLQuery2DragDrop(Sender, Source: TObject; X,Y: Integer);
    function FromClause(piNode: TTreeNode; var poPath: string): string;
    begin
      if piNode.Level = 1
      then begin
        poPath := acClassTicket(piNode.Data).PersistentObjectClassName;
        result := poPath;
      end
      else begin
        result := FromClause(piNode.Parent, poPath);
        poPath := poPath + '.' + copy(piNode.Text, 1, pred(pos(':', piNode.Text)));
        result := result + ', ' + #13#10 + '     ' + poPath;
      end;
    end;
var lCaption: string;
    lNode: TTreeNode;
    lPath: string;
    lFrom: string;
    lSelect: string;
begin
  if Source is TTreeView then
  begin
    lNode := TTreeView(Source).Selected;
    if (TObject(lNode.Data) is acClassTicket)
      then begin
        lCaption := acClassTicket(lNode.Data).PersistentObjectClassName;
        if GetKeyState(VK_CONTROL) < 0
           then SynEditOQL.SelText := #13#10 +
                                    'SELECT ' + lCaption + #13#10 +
                                    'FROM ' + lCaption
           else SynEditOQL.SelText := lCaption;
      end
      else if (TObject(lNode.Data) is acAttributeTicket) then
      begin
        if GetKeyState(VK_CONTROL) < 0
          then begin
            lCaption := (TObject(lNode.Parent.data) as acClassTicket).PersistentObjectClassName;
            lFrom := FromClause(lNode.Parent, lPath);
            lSelect := copy(lPath, 1, pred(pos('.', lPath)));
            if lSelect = '' then lSelect := lPath;
            SynEditOQL.SelText := #13#10 +
                                'SELECT ' + lSelect + #13#10 +
                                'FROM ' + lFrom + #13#10 +
                                'WHERE ' + lPath + '.' + acAttributeTicket(lNode.Data).AttributeName + ' = ';
          end else SynEditOQL.SelText := acAttributeTicket(lNode.Data).AttributeName;
      end;
  end;
end;

procedure TExplorerV2.memOQLQuery2DragOver(Sender, Source: TObject; X, Y: Integer; State: TDragState; var Accept: Boolean);
var
  lNode: TTreeNode;
begin
  if Source is TTreeView then
  begin
    if Accept then
    begin
      lNode := TTreeView(Source).Selected;
      Accept := ((TObject(lNode.Data) is acClassTicket) or (TObject(lNode.Data) is acAttributeTicket));
      if (State = dsDragEnter) and (Sender is TWinControl) then TWinControl(Sender).SetFocus;
    end
  end;
end;

procedure TExplorerV2.OQLObjectstvExplorerKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  // Copia dados do objeto ao apertar Ctrl + C
  if (Key = 67) and (Shift = [ssCtrl]) then
  begin
    if Assigned(OQLObjects.tvExplorer.Selected) then
      CopiaTextoObjeto(OQLObjects.tvExplorer.Selected);
  end;
end;

procedure TExplorerV2.OQLObjectstvExplorerMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  lPoint : TPoint;
begin
  GetCursorPos(lPoint);
  if (Button = mbRight) then
  begin
    pmCopiar.Popup(lPoint.X ,lPoint.Y );
  end;
end;

procedure TExplorerV2.pcEditorChange(Sender: TObject);
var
  lOQLtoSQLTranslator: acOQLtoSQLTranslator;
  lOQL: String;
begin
  if pcEditor.ActivePageIndex = 1 then
  begin
    try
      SynEditSQL.Text := '';
      if Trim(SynEditOQL.Text) <> '' then
        begin
          if OQLQuery.Checked then
          begin
            if SynEditOQL.SelText = ''
              then lOQL := SynEditOQL.Text
              else lOQL := SynEditOQL.SelText;

            lOQLtoSQLTranslator := acOQLtoSQLTranslator.Create(fMetaModelPersistenceMap);
            try
              SynEditSQL.Text := lOQLtoSQLTranslator.TranslateOQLtoSQL(Trim(lOQL), fSQLDialect, fSchema, acQueryResultKind.qrkObject);
              SynEditSQL.SetFocus;
            finally
              lOQLtoSQLTranslator.Free;
            end;
          end
          else
          begin
            if SynEditOQL.SelText = ''
              then lOQL := SynEditOQL.Text
              else lOQL := SynEditOQL.SelText;
            lOQLtoSQLTranslator := acOQLtoSQLTranslator.Create(fMetaModelPersistenceMap);
            try
              SynEditSQL.Text := lOQLtoSQLTranslator.TranslateOQLtoSQL(lOQL, fSQLDialect, fSchema, acQueryResultKind.qrkDataSet);
              SynEditSQL.SetFocus;
            finally
              lOQLtoSQLTranslator.Free;
            end;
          end;
        end;
      except
        on e: Exception do
          begin
            if not actResultsPanel.Checked then actResultsPanel.Execute;
            memErrorText.Text := e.Message;
            pcResults.ActivePageIndex := 1;
            pcEditor.ActivePageIndex := 0;
            sbStatusBar.Panels[0].Text := 'OQL translation to SQL failed.';
            sbStatusBar.Panels[1].Text := '';
            sbStatusBar.Panels[2].Text := '';
          end;
    end;
  end
  else SynEditOQL.SetFocus;
end;

procedure TExplorerV2.ReconnectDBExecute(Sender: TObject);
var lConnectionString: string;
    lSession: acPersistenceSession;
begin
  lConnectionString := fConnectionString;
  try
    fConnectionString := '';
    lSession := Connect;
    if Assigned(lSession)
      then lSession.Free
      else fConnectionString := lConnectionString;
  except
    fConnectionString := lConnectionString;
    raise;
  end;
end;

procedure TExplorerV2.ResizeColumns(piListView: TListView);
var li: integer;
begin
  if piListView.Columns.Count > 0 then
  begin
    piListView.Items.BeginUpdate;
    try
      for li := pred(piListView.Columns.Count) downto 0 do
      begin
        piListView.Columns.Items[li].Width := 0;
      end;
    finally
      piListView.Columns[0].Width := piListView.Columns[0].Width + 20;
      piListView.Items.EndUpdate;
    end;
  end;
end;

procedure TExplorerV2.SetMetaModel(const Value: acMetaModel);
var
  lNode :  TTreeNode;
begin
  fMetaModel := Value;
  lNode := tvModelExplorer.Items.AddChildObject(nil, 'Persistence Model', fMetaModel);
  lNode.HasChildren := True;
  lNode.Expand(False);
end;

procedure TExplorerV2.tvModelExplorerItemExpanding(Sender: TObject; Node: TTreeNode; var AllowExpansion: Boolean);
begin
  if rbSequencial.Checked then
  begin
    MontarModelExploreSequencial(Sender,Node);
  end
  else if rbHieraquia.Checked then
  begin
     MontarModelExploreHieraquia(Sender,Node);
  end;
end;

procedure TExplorerV2.XMLQueryExecute(Sender: TObject);
begin
  OQLQuery.Checked := False;
  XMLQuery.Checked := True;
end;

{ TDLLDialog }

constructor TDLLDialog.Create(aOwner: TComponent);
var
  BtnShowMessage: TButton;
  edt: TEdit;
begin
  inherited CreateNew(aOwner);

  Caption := 'This form is in a DLL !!!';
  Position := poWorkAreaCenter;
  Width := 200;
  Height := 100;

  BtnShowMessage := TButton.Create(Self);
  BtnShowMessage.Parent := Self;
  BtnShowMessage.Caption := 'Show message';
  BtnShowMessage.AutoSize := True;
  BtnShowMessage.OnClick := BtnShowMessageClick;
  edt := TEdit.Create(Self);
  edt.Parent := Self;

end;

procedure TDLLDialog.BtnShowMessageClick(Sender: TObject);
begin
  ShowMessage('Hello from DLL!');
end;

procedure TDLLDialog.CreateParams(var Params: TCreateParams);
begin
  inherited CreateParams(Params);

  {$IFDEF LCLWin32}
  Params.WndParent := ParentFormHandle;
  {$ENDIF}
end;

end.
